package dev.shadowsoffire.apotheosis.mixin;

import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import dev.shadowsoffire.apotheosis.adventure.socket.ReactiveSmithingRecipe;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.inventory.ContainerLevelAccess;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.world.inventory.MenuType;
import javax.annotation.Nullable;
import org.spongepowered.asm.mixin.Shadow;
import net.minecraft.world.item.crafting.SmithingRecipe;
import net.minecraft.world.inventory.SmithingMenu;
import org.spongepowered.asm.mixin.Mixin;
import net.minecraft.world.inventory.ItemCombinerMenu;

@Mixin({ SmithingMenu.class })
public abstract class SmithingMenuMixin extends ItemCombinerMenu
{
    @Shadow
    @Nullable
    private SmithingRecipe f_40242_;
    
    public SmithingMenuMixin(final MenuType<?> p_39773_, final int p_39774_, final Inventory p_39775_, final ContainerLevelAccess p_39776_) {
        super((MenuType)p_39773_, p_39774_, p_39775_, p_39776_);
    }
    
    @Inject(at = { @At("HEAD") }, method = { "onTake" })
    protected void onTake(final Player player, final ItemStack stack, final CallbackInfo ci) {
        final SmithingRecipe f_40242_ = this.f_40242_;
        if (f_40242_ instanceof final ReactiveSmithingRecipe ext) {
            ext.onCraft(this.f_39769_, player, stack);
        }
    }
}
